Package org.apache.sysds.runtime.controlprogram.parfor.opt

# Class OptTree

java.lang.Object
org.apache.sysds.runtime.controlprogram.parfor.opt.OptTree

public class OptTree extends Object
Represents a complete plan of a top-level parfor. This includes the internal representation of the actual current plan as well as additional meta information that are only kept once per program instead of for each and every plan alternative.

## Constructor Summary

Constructors
Constructor
Description
`OptTree(int ck, double cm, OptNode node)`
`OptTree(int ck, double cm, OptNode node, OptTreePlanMapping hlMap)`

## Method Summary

Modifier and Type
Method
Description
`String`
`explain(boolean withDetails)`
Explain tool: prints the hierarchical plan (including all available detail information, if necessary) to `stdout`.
`int`
`getCK()`
`double`
`getCM()`
`Hop`
`getMappedHop(long id)`
`Object[]`
`getMappedProg(long id)`
`ProgramBlock`
`getMappedProgramBlock(long id)`
`OptTreePlanMapping`
`getPlanMapping()`
`OptNode`
`getRoot()`
`void`
`setRoot(OptNode n)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### OptTree

public OptTree(int ck, double cm, OptNode node)

### OptTree

public OptTree(int ck, double cm, OptNode node, OptTreePlanMapping hlMap)

## Method Details

### getPlanMapping

public OptTreePlanMapping getPlanMapping()

### getMappedHop

public Hop getMappedHop(long id)

### getMappedProg

public Object[] getMappedProg(long id)

### getMappedProgramBlock

public ProgramBlock getMappedProgramBlock(long id)

### getCK

public int getCK()

### getCM

public double getCM()

### getRoot

public OptNode getRoot()

### setRoot

public void setRoot(OptNode n)

### explain

public String explain(boolean withDetails)
Explain tool: prints the hierarchical plan (including all available detail information, if necessary) to `stdout`.

Parameters:
  `withDetails` - if true, include explain details
Returns:
  string explanation